﻿using Infragistics.Controls;
using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartCustomZoomDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xmDataChart.WindowScaleHorizontal = xmDataChart.ActualWindowScaleHorizontal;
        }

        Point clickPoint;        
        private void xmDataChart_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            clickPoint = e.GetPosition(xmDataChart);
        }

        private void xmDataChart_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.RightButton == MouseButtonState.Pressed && Keyboard.Modifiers == ModifierKeys.Shift && clickPoint != null)
            {
                Point currentMousePoint = e.GetPosition(xmDataChart);

                bool movedLeft = false;

                double difference = 0;
                if(clickPoint.X > currentMousePoint.X)
                {
                    movedLeft = true;
                    difference = clickPoint.X - currentMousePoint.X;
                }
                else
                {
                    difference = currentMousePoint.X - clickPoint.X;
                }

                if(xmDataChart.WindowScaleHorizontal == double.NaN)
                {
                    xmDataChart.WindowScaleHorizontal = xmDataChart.ActualWindowScaleHorizontal;
                }

                double scaleMove = (difference / xmDataChart.ActualWidth) / 100;

                if (movedLeft) //zoom in
                {
                    if (xmDataChart.WindowScaleHorizontal - scaleMove > 0)
                    {
                        xmDataChart.WindowScaleHorizontal -= (difference / xmDataChart.ActualWidth) / 100;
                    }
                }
                else //zoom out
                {
                    if (xmDataChart.WindowScaleHorizontal + scaleMove < 1)
                    {
                        xmDataChart.WindowScaleHorizontal += (difference / xmDataChart.ActualWidth) / 100;
                    }
                }                

                //long deltaMouse;
                //GetXMousePositionOnChart(out var xpos);
                //GetYMousePositionOnChart(out var ypos);

                //var xMaxViewPort = xmDataChart.ViewportRect.Right;
                //var yMaxViewPort = xmDataChart.ViewportRect.Bottom;

                //var xAxis = xmDataChart.Axes[0] as NumericXAxis;
                //var yAxis = xmDataChart.Axes[1] as NumericYAxis;

                //var winRectContext = new Rect(0, 0, 1, 1);

                //var xScalerParams = new ScalerParams(winRectContext, xmDataChart.ViewportRect, xAxis.IsInverted);
                //var yScalerParams = new ScalerParams(winRectContext, xmDataChart.ViewportRect, yAxis.IsInverted);

                //if (xpos.Ticks > vm.XStartPosition)
                //    deltaMouse = xpos.Ticks - vm.XStartPosition;

                //else
                //    deltaMouse = vm.XStartPosition - xpos.Ticks;

                //var maxRange = xAxis.ActualMaximumValue;
                //var chartCenter = (xAxis.ActualMinimumValue + xAxis.MaximumValue) / 2;
                //var deltaRangeMax = (deltaMouse * 0.05 * maxRange) + (vm.XStartPosition - chartCenter);
                //var deltaRangeMin = (deltaMouse * 0.05 * maxRange) - (vm.XStartPosition - chartCenter);


                //if (vm.XStartPosition != xpos.Ticks)
                //    if (!xMaxViewPort.Equals(0))
                //    {
                //        xmDataChart.HorizontalZoombar.Range = new Range
                //        {
                //            Minimum = xAxis.GetScaledValue(deltaRangeMin, xScalerParams) / xMaxViewPort,
                //            Maximum = xAxis.GetScaledValue(deltaRangeMax, xScalerParams) / xMaxViewPort
                //        };
                //    }
            


            }
        }
    }
}
